      real function simpson(f, a, b, n)
c
c  Evaluates an integral using Simpson's rule
c
c  Local Variables
      implicit none

      integer i, n

      real f, a, b, h
      real x, feven, fodd, h2

      h = (b - a) / float(n)
      h2 = h * 2.0
c 
c  Sum even terms
      feven = 0.0
      x = a + h2
      do i = 2, n-2, 2
          feven = feven + f(x)
          x = x + h2
      enddo
c
c  Sum odd terms
      fodd = 0.0
      x = a + h
      do i = 1, n-1, 2
          fodd = fodd + f(x)
          x = x + h2
      enddo

      simpson = h * ((f(a)+f(b)) + (2.0*feven) + (4.0*fodd)) / 3.0

      return
      end




